dnl Test for CPU which is big-endian, 32b, with unaligned accesses
AC_DEFUN([AC_WAVE_CHECK_BE32_UNALIGNED_OK], [
AC_CACHE_CHECK([for big-endian, 32b arch. which allows unaligned accesses],
	ac_cv_wave_check_be32_unaligned_ok,
[AC_TRY_RUN([
#include "confdefs.h"
#define INT_AT_OFFSET(ptr,offset) (*((int *)(((char *) (ptr)) + (offset))))
int main ()
{
	char cs[8] = {0,1,2,3,4,5,6,7};

	if (sizeof (int) == 4 && INT_AT_OFFSET (cs, 0) == 0x00010203)
	{ /* BE and 32b, what about alignment */
		if (INT_AT_OFFSET (cs, 1) == 0x01020304 &&
			INT_AT_OFFSET (cs, 2) == 0x02030405)
		{ /* Try a store! */
			INT_AT_OFFSET (cs, 1) = INT_AT_OFFSET (cs, 2);

			if (INT_AT_OFFSET (cs, 1) = 0x02030405)
				return 0;
		}
	}
	return 1;
}],
ac_cv_wave_check_be32_unaligned_ok=yes,
ac_cv_wave_check_be32_unaligned_ok=no,
ac_cv_wave_check_be32_unaligned_ok=no)
])
if test "x$ac_cv_wave_check_be32_unaligned_ok" = xyes; then
	AC_DEFINE(WAVE_BE32_UNALIGNED_OK, 1, [BE, 32b, arch. with unaligned accesses])
fi
])
