/*
	The GTKWave electronic waveform viewer
	Copyright (C) 2000-2003 Department of Computer Science
	The University of Manchester, Oxford Road, Manchester, M13 9PL, UK
	Copyright (C) 1999-2003 Tony Bybell

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	`addtrace.h'
	Add traces dialogue box

	$Id: addtrace.h,v 1.4 2004/05/14 22:29:57 janinl Exp $
*/

#ifndef WAVE_ADDTRACE_H
#define WAVE_ADDTRACE_H

#include <gtk/gtk.h>

extern gboolean wave_add_traces_dialog_is_active (void);

/* wave_init_add_traces_dialog : make (or just raise) the `Add Traces' dialogue box */
extern void wave_init_add_traces_dialog (void);

/* wave_add_all_signals_to_trace : add all signals from the input file to the trace view */
extern void wave_add_all_signals_to_trace (void);

/* wave_remove_all_traces_from_display : remove all the traces from the display */
extern void wave_remove_all_signals_from_trace (void);

extern gboolean search_delete_callback (GtkWidget * widget, GdkEvent * event, gpointer user_data);
extern void search_hier_select_row_callback (GtkCList * clist, gint row, gint column, GdkEvent * event, gpointer user_data);
extern void search_hier_unselect_row_callback (GtkCList * clist, gint row, gint column, GdkEvent * event, gpointer user_data);
extern void search_regexp_entry_activate_callback (GtkEditable * editable, gpointer user_data);
extern void search_regexp_match_all_callback (GtkButton * button, gpointer user_data);
extern void search_regexp_unselect_all_callback (GtkButton * button, gpointer user_data);
extern void search_regexp_select_all_callback (GtkButton * button, gpointer user_data);
extern void search_regexp_list_select_row_callback (GtkCList * clist, gint row, gint column, GdkEvent * event, gpointer user_data);
extern void search_regexp_list_unselect_row_callback (GtkCList * clist, gint row, gint column, GdkEvent * event, gpointer user_data);
extern void search_append_callback (GtkButton * button, gpointer user_data);
extern void search_insert_callback (GtkButton * button, gpointer user_data);
extern void search_replace_callback (GtkButton * button, gpointer user_data);
extern void search_close_callback (GtkButton * button, gpointer user_data);
extern void on_traces_notebook_switch_page (GtkNotebook * notebook, GtkNotebookPage * page, gint page_num, gpointer user_data);
extern void on_regexp_type_clicked (GtkButton * button, gpointer user_data);
extern void on_hierarchy_entry_activate (GtkEditable * editable, gpointer user_data);
extern void on_show_all_traces_activate (GtkMenuItem *menuitem, gpointer user_data);
extern void on_show_all_confirm_ok_clicked (GtkButton *button, gpointer user_data);
extern void on_show_all_confirm_cancel_clicked (GtkButton *button, gpointer user_data);
extern gboolean on_show_all_confirm_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
extern void on_traces_add_traces_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_show_prefixes_activate (GtkMenuItem *menuitem, gpointer user_data);

#endif
