/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `analog.h'
    Analogue drawing functions and GUI elements

    $Id: analog.h,v 1.1 2003/04/14 00:14:09 bardslea Exp $
*/

#ifndef WAVE_ANALOG_H
#define WAVE_ANALOG_H

#include "draw.h"

typedef struct
{
    double from, to;
}
AnalogDrawerContext;

extern void *make_analog_trace_drawer_context (double from, double to);
extern gboolean set_analog_trace_drawer (TraceEnt * t, double from, double to);
extern gboolean get_analog_trace_config (TraceEnt * t, double *from_ptr, double *to_ptr);

extern TraceDrawer analog_trace_drawer;

/* Callbacks */
extern void on_set_analog_range_from_changed (GtkEditable * editable, gpointer user_data);
extern void on_set_analog_range_to_changed (GtkEditable * editable, gpointer user_data);
extern void on_set_analog_range_cancel_clicked (GtkButton * button, gpointer user_data);
extern void on_set_analog_range_ok_clicked (GtkButton * button, gpointer user_data);
extern void on_edit_display_format_analog_activate (GtkMenuItem * menuitem, gpointer user_data);

#endif
