/*
	The GTKWave electronic waveform viewer
	Copyright (C) 2000-2003 Department of Computer Science
	The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	`colorsel.h'
	Colour selection dialogue box

	$Id: colorsel.h,v 1.9 2003/01/26 23:18:30 bardslea Exp $
*/

#ifndef WAVE_COLORSEL_H
#define WAVE_COLORSEL_H

/* open_color_selection_dialog : create the colour selection dialogue box, populate it
	and make some convenience structures to store colours and GCs */
extern void open_color_selection_dialog (void);

extern gboolean color_examples_pane_expose_event (GtkWidget * widget, GdkEventExpose * event, gpointer user_data);

extern gboolean color_examples_pane_configure_event (GtkWidget * widget, GdkEventConfigure * event, gpointer user_data);

extern gboolean color_selection_dialog_dismiss (void);
extern gboolean custom_color_selection_dialog_dismiss (void);

extern void feature_colors_list_select_row (GtkCList * clist, gint row, gint column,
  GdkEvent * event, gpointer user_data);

/* custom_color_selection_color_changed : change colours in the examples panes */
extern void custom_color_selection_color_changed (GtkColorSelection * colorselection, gpointer user_data);

/* color_selection_dialog_apply : use `change color of...' notebook to decide
	where to copy the selected colours to */
extern void color_selection_dialog_apply (void);

/* color_selection_dialog_ok : do apply action then hide the window */
extern void color_selection_dialog_ok (GtkButton * button, gpointer user_data);

/* color_selection_change_colors_of_notebook_page_switched : renew decor/group lists */
extern void color_selection_change_colors_of_notebook_page_switched (GtkNotebook * notebook,
  GtkNotebookPage * page, gint page_num, gpointer user_data);

/* update_example_colors_clicked : update example colours from the colour source listed in the
	"Change Colors of ..." notebook */
extern void update_example_colors_clicked (GtkButton * button, gpointer user_data);

/* color_selection_decor_... : decor list handling callbacks */
extern void color_selection_decor_name_changed (GtkEditable * editable, gpointer user_data);
extern void color_selection_decor_new_clicked (GtkButton * button, gpointer user_data);
extern void color_selection_decor_delete_clicked (GtkButton * button, gpointer user_data);
extern void color_selection_decor_row_selected (GtkCList * clist, gint row, gint column,
  GdkEvent * event, gpointer user_data);

/* color_selection_selected_traces_trace_group_clicked : update colours of selected traces to use colour
	from their preselected trace groups */
extern void color_selection_selected_traces_trace_group_colors_clicked (void);

/* color_selection_selected_traces_decor_selected : update colours of selected traces from a single
	decor */
extern void color_selection_selected_traces_decor_selected (void);

/* color_selection_group_decor_selected : actions when a decor is selected for
	a trace group */
extern void color_selection_group_decor_selected (void);

/* ...private_colors_clicked : update colours when the "Private Colors" buttons are clicked */
extern void color_selection_selected_traces_private_colors_clicked (void);
extern void color_selection_group_private_colors_clicked (void);

/* color_selection_custom_color_clicked : show the custom colour selection dialogue */
extern void color_selection_custom_color_clicked (GtkButton * button, gpointer user_data);

#endif
