/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `command.h'
    Command line interaction

    $Id: command.h,v 1.2 2003/06/24 21:57:42 bardslea Exp $
*/

#ifndef WAVE_COMMAND_H
#define WAVE_COMMAND_H

#include "fileio.h"
#include <glib.h>

/* wave_command_{parser,response_stream} : command line parser (line parser)
	and response streams */
extern FileDescLineParser *wave_command_parser;
extern FILE *wave_command_response_stream;

/* wave_command_try_to_open: try to open a wave command
	line on the given file descriptors.  Returns a success value. */
extern gboolean wave_command_try_to_open (int in_fd, int out_fd);

#endif
