/*
    GTKWave Trace Configuration Library - libwaveconfig
    Copyright (C) 2002-2003 Esterel Technologies [http://www.esterel-technologies.com]
    Copyright (C) 2002-2003 The University of Manchester

    The authors of this library can be contacted through the GTKWave maintainer.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    `group.h'
    Trace group handling

    $Id: group.h,v 1.12 2003/02/05 12:03:08 bardslea Exp $
*/

#ifndef WAVE_CONFIG_GROUP_H
#define WAVE_CONFIG_GROUP_H

#include "config/color.h"

typedef struct TraceGroup_
{
    char *name;
    TraceDecor *decor;
    TraceStateColors *state_colors;
}
TraceGroup;

/* new_trace_group : allocate a TraceGroup and set its name */
extern TraceGroup *new_trace_group (char *name);

/* free_trace_group : destructor for trace group structures */
extern void free_trace_group (TraceGroup * group);

/* copy_trace_group : deep copy a trace group */
extern TraceGroup *copy_trace_group (TraceGroup * group);

/* find_trace_group_in_list : find a group in a list of groups */
extern TraceGroup *find_trace_group_in_list (GList * groups, const char *name);

#endif
