/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `currenttime.c'
    Time and marker handling

    $Id: currenttime.c,v 1.32 2003/11/11 22:53:27 bardslea Exp $
*/

#include <gtk/gtk.h>
#include "currenttime.h"
#include "utils.h"
#include "rc.h"
#include "tracepane.h"
#include "support.h"

BlackoutRegion *blackout_regions = NULL;

/* Maximum string length to hold a formatted time */
#define WAVE_MAX_TIME_LENGTH (40)

void update_markertime (TimeType val)
{
	static char *maxtext = NULL;

    if (maxtext == NULL)
		maxtext = g_new (char, WAVE_MAX_TIME_LENGTH);

	if (val >= 0)
	{
		if (tims.lmbcache >= 0)
			val -= tims.lmbcache; /* do delta instead */

		if (tims.lmbcache >= 0 && val >= 0)
		{
			*maxtext = '+';
			wave_format_time (maxtext + 1, val, wave_config->time_dimension);
		} else
			wave_format_time (maxtext, val, wave_config->time_dimension);
	} else
		sprintf (maxtext, "--");

    gtk_label_set_text (GTK_LABEL (lookup_widget (wave_window->window, "primary_marker_time")), maxtext);
}

void update_currenttime (TimeType val)
{
	static char *curtext = NULL;

    if (curtext == NULL)
        curtext = g_new (char, WAVE_MAX_TIME_LENGTH);

    wave_format_time (curtext, val, wave_config->time_dimension);
    gtk_label_set_text (GTK_LABEL (lookup_widget (wave_window->window, "cursor_time")), curtext);
}

