/*
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `currenttime.h'
    Time and marker handling (and other general declarations)

    $Id: currenttime.h,v 1.57 2003/11/11 22:53:27 bardslea Exp $
*/

#ifndef WAVE_CURRENTTIME_H
#define WAVE_CURRENTTIME_H

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "analyzer.h"
#include "../config.h"

#define WAVE_TITLE ("GTKWave Waveform Viewer " VERSION)
#define WAVE_COPYRIGHT_INFO ( \
"Licensed under the GNU GPL\n" \
"(C) 1999-2003 Tony Bybell\n" \
"(C) 2000-2003 The University of Manchester\n" \
"    and other contributors" )

/* FIXME, this *really* should be done with a state */
typedef struct BlackoutRegion_
{
    struct BlackoutRegion_ *next;
    TimeType bstart, bend;
}
BlackoutRegion;

extern BlackoutRegion *blackout_regions;

extern gdouble page_divisor;    /* allows fractional page scrolls */

extern int font_height_override; /* force fontheight to be larger */

extern char *fontname_signals, *fontname_waves;

extern void update_markertime (TimeType val);
extern void update_currenttime (TimeType val);

extern void tracesearchbox (char *title, GtkSignalFunc func);

extern int wave_regex_compile (char *regex);
extern int wave_regex_match (char *str);

#endif
