/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `error.h'
    Error context handling

    $Id: error.h,v 1.2 2003/07/13 15:37:14 bardslea Exp $
*/

#ifndef WAVE_ERROR_H
#define WAVE_ERROR_H

/* WaveErrorContext : context for error message:
	operation_name:filename:line_num */
typedef struct
{
	const char *operation_name;
	const char *filename;
	int line_num;
}
WaveErrorContext;

/* wave_new_error_context : make a new error context structure and populate with default values */
WaveErrorContext *wave_new_error_context (void);

#endif
