/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `fgetdynamic.c'
    fget(3) with dynamic allocation

    $Id: fgetdynamic.c,v 1.10 2003/04/11 15:22:23 bardslea Exp $
*/

#include <glib.h>
#include "fgetdynamic.h"

struct alloc_bytechain
{
    char val;
    struct alloc_bytechain *next;
};
static int fgetmalloc_len;

char *fgetmalloc (FILE * handle)
{
    char *pnt, *pnt2;
    struct alloc_bytechain *bytechain_root = NULL, *bytechain_current = NULL;
    int ch;

    fgetmalloc_len = 0;

    for (;;)
    {
        ch = fgetc (handle);
        if ((ch == EOF) || (ch == 0x00) || (ch == '\n') || (ch == '\r'))
            break;
        fgetmalloc_len++;
        if (bytechain_current)
        {
            bytechain_current->next = wave_alloca (sizeof (struct alloc_bytechain));
            bytechain_current = bytechain_current->next;
            bytechain_current->val = (char) ch;
            bytechain_current->next = NULL;
        } else
        {
            bytechain_root = bytechain_current = wave_alloca (sizeof (struct alloc_bytechain));
            bytechain_current->val = (char) ch;
            bytechain_current->next = NULL;
        }
    }

    if (!fgetmalloc_len)
    {
        return (NULL);
    } else
    {
        pnt = pnt2 = g_new (char, fgetmalloc_len + 1);
        while (bytechain_root)
        {
            *(pnt2++) = bytechain_root->val;
            bytechain_root = bytechain_root->next;
        }
        *(pnt2) = 0;

        return (pnt);
    }
}
