/*
	The GTKWave electronic waveform viewer
	Copyright (C) 2000-2003 Department of Computer Science
	The University of Manchester, Oxford Road, Manchester, M13 9PL, UK
	Copyright (C) 1999-2003 Tony Bybell

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	`gui_cb.h'
	GUI Callbacks

	$Id: gui_cb.h,v 1.51 2003/11/11 13:24:49 bardslea Exp $
*/

#include <gtk/gtk.h>

#include "colorsel.h"

#include "addtrace.h"
#include "analog.h"
#include "digital.h"
#include "marker.h"
#include "print.h"
#include "navigate.h"
#include "log.h"
#include "rc.h"
#include "polling.h"
#include "help.h"
#include "tracefile.h"
#include "tracepane.h"
#include "signalpane.h"

extern void on_file_open_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_file_quit_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_insert_separator_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_insert_comment_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_change_trace_name_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_cut_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_paste_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_hex_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_decimal_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_formal_signed_decimal_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_binary_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_formal_octal_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_right_justify_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_invert_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_reverse_bits_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_hide_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_show_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_select_regexp_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_select_all_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_unselect_all_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_pattern_search_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void search_signals_notebook_switch_page (GtkNotebook * notebook, GtkNotebookPage * page, gint page_num,
  gpointer user_data);
extern gboolean on_top_level_delete_event (GtkWidget * widget, GdkEvent * event, gpointer user_data);
extern void on_edit_data_format_octal_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_signed_decimal_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_ascii_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_data_format_justify_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_sort_ascii_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_sort_dict_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_sort_sigsort_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_sort_rev_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_edit_contract_trace_menuitem_activate (GtkMenuItem *menuitem, gpointer user_data);
extern void on_edit_extend_trace_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_traces_menu_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_handlebox_toggle_clicked (GtkButton * button, gpointer user_data);
extern void on_filter_dialog_ok (GtkButton * button, gpointer user_data);
extern void on_filter_dialog_cancel (GtkButton * button, gpointer user_data);
extern void on_display_format_filter_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_comment_dialog_cancel_clicked (GtkButton *button, gpointer user_data);
extern void on_comment_dialog_ok_clicked (GtkButton *button, gpointer user_data);
extern gboolean on_about_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
extern void on_about_dialog_close_clicked (GtkButton *button, gpointer user_data);
extern gboolean on_comment_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
extern void on_trace_name_dialog_cancel_clicked (GtkButton *button, gpointer user_data);
extern void on_trace_name_dialog_ok_clicked (GtkButton *button, gpointer user_data);
extern gboolean on_trace_name_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
extern void on_select_regexp_dialog_cancel_clicked (GtkButton *button, gpointer user_data);
extern void on_select_regexp_dialog_ok_clicked (GtkButton *button, gpointer user_data);
extern gboolean on_select_regexp_dialog_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);

extern GtkWidget *build_main_window (void);

/* ------8<-----CUT HERE-----8<------- */
