/*
    The GTKWave electronic waveform viewer
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `help.h'
    Declarations of help strings.
*/

#ifndef WAVE_HELP

#include <gtk/gtk.h>

/* wave_create_help_window : create the help window making menu/button functions report usage
	rather than working normally */
extern void wave_create_help_window (const char *title, int width, const char *default_text);

/* wave_help : report help information if the help window is showing.
	`bold_string' should be the help title and `normal_string' (if not
	empty/NULL should be the explanation, returns TRUE if we're in
	help mode */
extern gboolean wave_help (const char *bold_string, const char *normal_string);

/* Callbacks and GUI stuff */
extern void on_help_menu_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_help_about_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_help_wave_help_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);

#endif /* WAVE_HELP */
