/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `main.h'
    GTKWave top level

    $Id: main.h,v 1.24 2003/11/09 23:36:22 bardslea Exp $
*/

#ifndef WAVE_MAIN_H
#define WAVE_MAIN_H

#include <glib.h>
#include "polling.h"

/* wave_{about_title,copyright_info} : usage and about dialogue messages */ 
const char *wave_about_title;
const char *wave_copyright_info;

extern gboolean wave_debug_ab;

/* Set to true once one (or more!) main windows has been spawned */
extern gboolean wave_have_main_window;

extern WaveFilePollingInfo *wave_polling;

/* wave_load_trace_file : load a trace file from `filename'.  If `reader_name'
	is not NULL, then use that as the name of the reader format to use. */
WaveReader *wave_load_trace_file (char *filename, char *reader_name);

#endif
