/*
	The GTKWave electronic waveform viewer
	Copyright (C) 2000-2003 Department of Computer Science
	The University of Manchester, Oxford Road, Manchester, M13 9PL, UK
	Copyright (C) 1999-2003 Tony Bybell

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

	`marker.h'
	Markers handling (and GUI elements)

	$Id: marker.h,v 1.3 2003/11/11 13:24:50 bardslea Exp $
*/

#ifndef WAVE_MARKER_H
#define WAVE_MARKER_H

#include "config/global.h"

extern TimeType named_markers[26];

/* wave_init_marker_dialog : make (or just raise) the marker editing dialog */
extern void wave_init_marker_dialog (void);

/* Callbacks */
extern gboolean markers_sort_by_name (GtkWidget * widget, GdkEventButton * event, gpointer user_data);
extern gboolean markers_sort_by_position (GtkWidget * widget, GdkEventButton * event, gpointer user_data);
extern gboolean on_marker_dialog_delete_event (GtkWidget * widget, GdkEvent * event, gpointer user_data);
extern void on_marker_list_select_row (GtkCList * clist, gint row, gint column, GdkEvent * event, gpointer user_data);
extern void on_marker_list_unselect_row (GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data);
extern void on_markers_close_clicked (GtkButton * button, gpointer user_data);
extern void on_markers_accept_clicked (GtkButton * button, gpointer user_data);
extern void on_markers_menu_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_markers_edit_markers_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_markers_place_marker_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_markers_remove_marker_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_markers_collect_all_named_markers_menuitem_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_marker_entry_changed (GtkEditable *editable, gpointer user_data);
extern void on_marker_entry_activate (GtkEditable *editable, gpointer user_data);
extern void on_marker_delete_clicked (GtkButton *button, gpointer user_data);

#endif
