/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

   `signalpane.c'
   Signal pane setup/callbacks

   $Id: signalpane.h,v 1.7 2004/05/14 22:29:57 janinl Exp $
*/

#ifndef WAVE_SIGNALPANE_H
#define WAVE_SIGNALPANE_H

#include <gtk/gtk.h>
#include "analyzer.h"
#include "draw.h"
#include "view.h"

/* Signal pane globals, kill 'em FIXME */
extern GdkFont *signalfont;
extern int fontheight;
extern gboolean wave_dnd_state;
extern gboolean wave_show_prefixes_state;

/* wave_dnd_error : complain about certain ops conflict with dnd... */
extern void wave_dnd_error (void);

/* wave_redraw_signal_pane : redraw signal pane of main window */
extern void wave_redraw_signal_pane (WaveWindow *window);

/* wave_create_signal_pane : create signal pane widgets */
extern void wave_create_signal_pane (WaveWindow *window);

/* wave_max_signal_length : calculate maximum signal name length */
extern void wave_max_signal_length (WaveWindow *window);

/* wave_render_signal_names_background : paint the background and ``Time'' message in the signal pane */
extern void wave_render_signal_names_background (WaveWindow *window);

/* wave_render_signal_name{,s} : render signal name{,s} in the signal pane */
extern int wave_render_signal_name (TraceEnt * t, int i, gboolean paint_background, WaveWindow *window);
extern void wave_render_signal_names (WaveDrawingContext *context, int first_trace_line, WaveWindow *window);

/* wave_signal_pane_adjust_after_insertion : adjust the signal pane scroll bar after
	a signal insertion */
extern void wave_signal_pane_adjust_after_insertion (WaveWindow *window);

/* GUI */
extern gboolean on_signal_drawing_area_configure_event (GtkWidget *widget,
	GdkEventConfigure *event, WaveWindow *window);
extern gboolean on_signal_drawing_area_expose_event (GtkWidget *widget,
	GdkEventExpose *event, WaveWindow *window);
extern gboolean on_signal_drawing_area_button_press_event (GtkWidget *widget,
	GdkEventButton *event, WaveWindow *window);
extern gboolean on_signal_drawing_area_button_release_event (GtkWidget *widget,
	GdkEventButton *event, WaveWindow *window);
extern gboolean on_signal_drawing_area_motion_notify_event (GtkWidget *widget,
	GdkEventMotion *event, WaveWindow *window);

#endif
