/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `strace.h'
    Signal trace dialogue and search functions

    $Id: strace.h,v 1.11 2003/08/05 22:55:05 bardslea Exp $
*/

#ifndef WAVE_STRACE_H
#define WAVE_STRACE_H

#include <gtk/gtk.h>
#include <string.h>
#include "analyzer.h"
#include "currenttime.h"
#include "bsearch.h"

enum strace_directions
{ STRACE_BACKWARD, STRACE_FORWARD };

struct STrace_;

typedef struct
{
    struct STrace_ *parent;
    int which;
}
STraceBack;

typedef struct STrace_
{
    struct STrace_ *next;
    char *string;               /* free this when all's done! */
    TraceEnt *trace;
    char value;
    char search_result;

    union
    {
        // HistEnt *h;             /* what makes up this trace */
    }
    his;

    STraceBack *back[9]; /* dealloc these too! */
}
STrace;

typedef struct TimeChain_
{
    struct TimeChain_ *next;
    TimeType t;
}
TimeChain;

extern STrace *straces;
extern TimeType *timearray;
extern int timearray_size;

extern void strace_error (void);
extern void strace_search (int direction);

#endif
