/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `tracefile.h'
    Saved traces file parsing

    $Id: tracefile.h,v 1.7 2003/05/05 20:27:15 bardslea Exp $
*/

#ifndef WAVE_TRACEFILE_H
#define WAVE_TRACEFILE_H

#include "analyzer.h"
#include "config/global.h"

/* update_wave_config_from_traces : make the `wave_config->traces'
	element match the current state of the wave_drawing_area as described by the TraceEnts
	linked from `traces' */
extern void update_wave_config_from_traces (TraceEnt * traces, WaveConfig * wave_config);

/* add_traces_from_trace_config_list : add each trace from a parsed WaveConfig
	to the wave_drawing_area trace view pane */
extern void add_traces_from_trace_config_list (GList * trace_configs);

/* Callbacks and GUI stuff */
extern void on_file_open_traces_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_load_traces_ok_clicked (GtkButton * button, gpointer user_data);
extern void on_load_traces_cancel_clicked (GtkButton * button, gpointer user_data);
extern void on_file_save_traces_activate (GtkMenuItem * menuitem, gpointer user_data);
extern void on_save_traces_ok_clicked (GtkButton * button, gpointer user_data);
extern void on_save_traces_cancel_clicked (GtkButton * button, gpointer user_data);

#endif
