/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `tracepane.h'
    Trace display rendering

    $Id: tracepane.h,v 1.6 2004/04/25 19:23:42 bardslea Exp $
*/

#include "currenttime.h"
#include "draw.h"
#include "view.h"

#ifndef WAVE_TRACEPANE_H
#define WAVE_TRACEPANE_H

/* Wave pane global, kill 'em too FIXME */
extern TraceEnt *trace_pane_topmost_trace;
extern GdkFont *wavefont;
extern GdkFont *wavefont_smaller;
extern WaveDrawingContext *wave_window_drawing_context;

/* wave_pane_width_in_time_units : returns the wave pane width in the current base time units */
extern TimeType wave_pane_width_in_time_units (WaveWindow *window);

/* render_{times,traces} : render the time bar (ruler) and vertical grid lines / traces */
extern void render_times (WaveDrawingContext *context, WaveWindow *window);
extern void render_traces (WaveDrawingContext *context, WaveWindow *window);

/* wave_create_trace_pane : create a main window trace pane */
extern void wave_create_trace_pane (WaveWindow *window);

/* wave_redraw : redraw main window signals and traces */
extern void wave_redraw (WaveWindow *window);

/* wave_redraw_trace_pane : redraw only the trace pane */
extern void wave_redraw_trace_pane (WaveWindow *window);

/* GUI */
extern gboolean on_traces_drawing_area_button_press_event (GtkWidget *widget,
	GdkEventButton *event, WaveWindow *window);
extern gboolean on_traces_drawing_area_button_release_event (GtkWidget *widget,
	GdkEventButton *event, WaveWindow *window);
extern gboolean on_traces_drawing_area_motion_notify_event (GtkWidget *widget,
	GdkEventMotion *event, WaveWindow *window);
extern gboolean on_traces_drawing_area_configure_event (GtkWidget *widget,
	GdkEventConfigure *event, WaveWindow *window);
extern gboolean on_traces_drawing_area_expose_event (GtkWidget *widget,
	GdkEventExpose *event, WaveWindow *window);

#endif
