/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    
    `tree.h'
    Signal search tree dialogue tree handling

    $Id: tree.h,v 1.16 2003/07/08 22:24:26 bardslea Exp $
*/

#ifndef WAVE_TREE_H
#define WAVE_TREE_H

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"

extern char hier_delimiter;
extern gboolean hier_was_explicitly_set;
extern char alt_hier_delimiter;
extern struct tree *selectedtree;

typedef struct SignalTree_
{
    struct SignalTree_ *parent; /* NULL if toplevel */
    struct SignalTree_ *next;
    struct SignalTree_ *child;
    char *name;
    int which;                  /* 'i' for wave_symbols[i] table, -1 means not a full signame */
}
SignalTree;

/* Think about using glib collections instead of ..chain types AB FIXME */
typedef struct SignalTreeChain_
{
    SignalTree *tree;           /* top of list of selected item in hierarchy */
    SignalTree *label;          /* actual selected item in hierarchy */
    struct SignalTreeChain_ *next;
}
SignalTreeChain;

extern SignalTree *treeroot;

void init_tree (void);
void build_tree_from_name (char *s, int which);
int treeprune (SignalTree * t);

#ifdef DEBUG_FACILITIES
void treedebug (SignalTree * t, char *s);
#endif
void maketree (GtkCTreeNode * subtree, SignalTree * t);

#endif
