/*    
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `value.h'
    Trace data value handling and print formatting

    $Id: value.h,v 1.6 2003/08/05 22:55:05 bardslea Exp $
*/

#ifndef WAVE_VALUE_H
#define WAVE_VALUE_H

#include "analyzer.h"
#include "event.h"

/* wave_invert_digital_value : invert the values '0XZ1' by mapping onto '1XZ0' */
extern char wave_invert_digital_value (char val);

/* wave_event_value_string : convert a WaveEvent's value into a newly allocated string
	representation of that value.  `trace_ent' is allowed to be NULL */
extern char *wave_event_value_string (TraceEnt *trace_ent, WaveEvent *event);

/* wave_event_digital_value : return the value of the digital bit in the
	given WaveEvent, note that the Node for this event *must* be DIGITAL */
extern char wave_event_digital_value (TraceConfig *trace_config, WaveEvent *event);

/* wave_event_handshake_string : format a suitable printed representation
	of a handshake signal.  Only returns the data on the channel (or "") if
	`data_value_only' is TRUE. If `trace_ent' is NULL then use an appropriate
	fallback representation */
extern char *wave_event_handshake_string (TraceEnt *trace_ent, WaveEvent *event,
	gboolean data_value_only);

/* wave_node_event_type_name : returns a printable form of the type portion of
	the given node flags */
extern char *wave_node_event_type_name (NodeFlags flag);

#endif
