/*
    The GTKWave electronic waveform viewer
    Copyright (C) 1999-2003 Tony Bybell
    Copyright (C) 2000-2003 Department of Computer Science
    The University of Manchester, Oxford Road, Manchester, M13 9PL, UK

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

    `view.h'
    Trace window representing type

    $Id: view.h,v 1.5 2003/11/13 11:05:38 bardslea Exp $
*/

#ifndef WAVE_VIEW_H
#define WAVE_VIEW_H

#include <gtk/gtk.h>
#include "analyzer.h"
#include "config/global.h"

/* WaveDisplayScale : encapsulation for time scale to display page/pixel sizes */
typedef struct
{
	/* Pane scale to time units */
	TimeType time_units_per_frame, pixels_per_frame;
	TimeType tickstep;
	gdouble pixels_per_time_unit, time_units_per_pixel;

	/* Pane pixel sizes */
	int wave_pane_height, wave_pane_width;
	int time_line_y; /* y ordinate of time/ruler horiz. line */
}
WaveDisplayScale;

typedef struct
{
	GtkWidget *window; /* Main window */
	struct {
		GtkWidget *drawing_area;
		GdkPixmap *pixmap;
		GtkWidget *window;
		gboolean window_width_dirty;
		GtkAdjustment *hslider;
		int pixmap_width, pixmap_height;
		int fill_width, fill_height;
		int name_width;
		TraceEnt *shift_click_trace;
	} signals;
	struct {
		GtkWidget *window;
		GtkWidget *drawing_area;
		GtkAdjustment *vslider, *hslider;
		WaveDisplayScale scale;
		TraceEnt *top_visible_trace;
	} traces;
}
WaveWindow;

#define WAVE_MIN_SIGNAL_PANE_WIDTH (100)

/* wave_new_window : make a new wave window structure */
extern WaveWindow *wave_new_window (void);

/* FIXME, global corresponding to single window */
extern WaveWindow *wave_window;

#endif
